package externaloutage.view;

import com.oracle.ugbu.ss.outage.geomap.model.beans.OutageSummaryInfoBean;

import java.util.Map;
import java.util.UUID;

import oracle.adf.share.logging.ADFLogger;


public class ExternalOutageSummaryInfoBean extends OutageSummaryInfoBean{
    ADFLogger _Logger =
        ADFLogger.createADFLogger(ExternalOutageSummaryInfoBean.class.getPackage());

      private String mRowId;
      private String mOutageArea;

      private String mNumCustomersAffected;
      private String mNumOutages;
      private String mTotalCustomersServed;

      private String mbMETA;
      private String mLastUpdatedTime;
      private String mBeginTime;

      public String getNumCustomersAffected()
      {
        return mNumCustomersAffected;
      }

      public String getMobEstimatedFixTime()
      {
        return mbMETA;
      }

      public String getMobLastUpdatedTime()
      {
        return mLastUpdatedTime;
      }

      public String getMobBeginTime()
      {
        return mBeginTime;
      }

      public ExternalOutageSummaryInfoBean(Map<String, String> dataValuesMap)
      {
        super(dataValuesMap);  
        mRowId = UUID.randomUUID().toString();
        mOutageArea = dataValuesMap.get("area");
        mNumCustomersAffected = dataValuesMap.get("custOut");
        mTotalCustomersServed = dataValuesMap.get("custServed");
        mNumOutages = dataValuesMap.get("numOutages");
        try
        {
          mBeginTime =
              dateFormat(dataValuesMap.get("earliestBeginTime"));
          mbMETA = dateFormat(dataValuesMap.get("eta"));
          mLastUpdatedTime = dateFormat(dataValuesMap.get("lastUpdated"));
        }
        catch (Exception e)
        {
          _Logger.warning(e.getLocalizedMessage());
        }

      }

      public String getNumOutages()
      {
        return mNumOutages;
      }

      public String getOutageArea()
      {
        return mOutageArea;
      }

      public String getTotalCustomersServed()
      {
        return mTotalCustomersServed;
      }

      public String getRowId()
      {
        return mRowId;
      }
	  
	  public String dateFormat(String dateConvert) throws java.text.ParseException{
		java.text.DateFormat odf = new java.text.SimpleDateFormat("MM/dd/yy hh:mm a");
		java.text.DateFormat idf = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		java.util.Date d= idf.parse(dateConvert);
		dateConvert=odf.format(d);
		return dateConvert;
	}
	  
}



